/*
 * Copyright (C) 1998 LAAS/CNRS -- RIA --
 *
 * Maher Khatib - Wed Feb  4 1998
 *
 */
#ifndef _SICK_LOCAL_STR_H_
#define _SICK_LOCAL_STR_H_

#include "sick_sin_cos.h"

/* Conversion radians -> degres */
#define  C_RAD_DEG           (180./PI)

/* Sin et cos de l'angle en degre avec:  -180 <= angle <= 180 */
#define SICK_SIN_DEG_FAST(x)      (sick_sin_tab[(int)((x * 2) + 360 + .5)])
#define SICK_COS_DEG_FAST(x)      (sick_cos_tab[(int)((x * 2) + 360 + .5)])

/* Sin et cos de l'angle en radian avec:  -PI <= angle <= PI */
#define SICK_SIN_FAST(x)      (sick_sin_tab[(int)(C_RAD_DEG * x * 2 + 360 + .5)])
#define SICK_COS_FAST(x)      (sick_cos_tab[(int)(C_RAD_DEG * x * 2 + 360 + .5)])

/* default baud rate */
#define SICK_SERIAL_DEFAULT_RATE  SICK_LIB_DEFAULT_TR_RATE

/* response time out */
#define SICK_REPONSE_TIME_MAX   (25 * sysClkRateGet())  /* 25 sec */

/* reset cmds */
#define SICK_RESET_CMDS_LIST {\
  SICK_RESET_STATE, \
  SICK_READ_STATUS_STATE, \
  SICK_READ_CONFIG_STATE, \
  SICK_CONFIG_MODE_STATE, \
  SICK_SET_MEASURE_UNIT_STATE, \
  SICK_SET_SCANNING_PARAMETERS_STATE, \
  SICK_SET_BAUD_RATE_STATE, \
  }

/* reset cmds number */
#define SICK_RESET_CMDS_LIST_NUMBER  (7)


/* robot position + var + speed */
typedef struct sick_var_position_str {
  POM_EULER robotPos;
  double trailerAngle;
  double var[6];
  double v, w, trailerW;
} SICK_VAR_POSITION_STR;

/* stack length of robot position */
/* Must allow to record as many pos as one can read during a sick acquisition */
#define SICK_N_ROBOT_POS             (30)

#endif /* _SICK_LOCAL_STR_H_ */
